(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  PuppetEnterpriseConsole.ResourcesController = (function(_super) {

    __extends(ResourcesController, _super);

    function ResourcesController() {
      return ResourcesController.__super__.constructor.apply(this, arguments);
    }

    ResourcesController.prototype.routingKey = 'resources';

    ResourcesController.beforeFilter(function() {
      return PuppetEnterpriseConsole.set('active', 'resources');
    });

    ResourcesController.beforeFilter(function() {
      return this.set('inputs', new Batman.Object);
    });

    ResourcesController.prototype.index = function() {
      return this.unset('type');
    };

    ResourcesController.prototype.show = function(_arg) {
      var id;
      id = _arg.id;
      this.set('type', id);
      this.set('inputs.title', '');
      this.set('title', '');
      this.set('klass', PuppetEnterpriseConsole.Resource[id]);
      this.set('sortBy', 'title');
      return this.set('resources', this.get('klass').get('loadedForSelection'));
    };

    ResourcesController.prototype.details = function(params) {
      var title, type;
      type = params.type || Batman.helpers.singularize(params.resource);
      title = params.title || params.id;
      if (!title) {
        return this.redirect(type);
      }
      this.set('type', type);
      this.set('typeclass', new Batman.UniqueSetIndex(PuppetEnterpriseConsole.ResourceType.get('loaded'), 'id').get(type));
      this.set('klass', PuppetEnterpriseConsole.Resource[type]);
      this.set('inputs.title', title);
      return this.set('title', title);
    };

    ResourcesController.accessor('resource', function() {
      var klass, obj,
        _this = this;
      klass = this.get('klass');
      klass.get('loaded.length');
      PuppetEnterpriseConsole.Node.get('nodeSetID');
      if (!this.get('title')) {
        return;
      }
      obj = new klass(this.get('title'));
      obj.set('diffprops', new Batman.Set);
      obj.set('nodiffprops', new Batman.Set);
      obj.load(function(error, data) {
        var variations;
        if (!error) {
          variations = data.get("variations");
          return data.get("properties").forEach(function(p) {
            var has_diff, prop, v, _i, _len, _ref;
            has_diff = false;
            for (_i = 0, _len = variations.length; _i < _len; _i++) {
              v = variations[_i];
              if (typeof prop === "undefined" || prop === null) {
                prop = (_ref = JSON.stringify(v.attributes[p])) != null ? _ref : '';
              }
              if (prop !== JSON.stringify(v.attributes[p])) {
                has_diff = true;
                data.get('diffprops').add(p);
                break;
              }
            }
            if (!has_diff) {
              return data.get('nodiffprops').add(p);
            }
          });
        }
      });
      return obj;
    });

    ResourcesController.prototype.doSearch = function(form) {
      if (!this.get('inputs.title')) {
        return;
      }
      return Batman.redirect({
        controller: 'resources',
        action: 'details',
        type: this.get('type'),
        title: this.get('inputs.title')
      });
    };

    ResourcesController.prototype.resetSearch = function(btn) {
      if (!this.get('title')) {
        return this.set('inputs.title', '');
      }
      return Batman.redirect({
        controller: 'resources',
        action: 'show',
        id: this.get('type')
      });
    };

    ResourcesController.prototype.changeSort = function(_, sortKey) {
      if (sortKey === this.get('sortBy')) {
        return this.set('sortBy', "" + sortKey + " desc");
      } else {
        return this.set('sortBy', sortKey);
      }
    };

    ResourcesController.prototype.reloadAll = function() {
      PuppetEnterpriseConsole.Node.selectAll();
      return PuppetEnterpriseConsole.ResourceType.get('all').forEach(function(type) {
        return PuppetEnterpriseConsole.Resource[type.get('name')].invalidate().get('forSelection');
      });
    };

    ResourcesController.prototype.refreshResource = function() {
      return this.get('klass').invalidate().get('forSelection');
    };

    return ResourcesController;

  })(Batman.Controller);

}).call(this);
