module CSVExport
  HEADERS = %w[baseline hostname type title property same? baseline inspected]

  def send_csv(headers, options=nil)
    headers, options = HEADERS, headers if options.nil?
    data = (options[:data] || []).unshift(headers)
    csv = data.map do |row|
      row = row.map do |cell|
        cell = case cell
        when Date, Time, DateTime
          cell.to_s(:db)
        when Symbol
          cell.to_s.inspect
        when NilClass
          ''
        else
          cell.inspect
        end
      end
      row.join(',') + "\n"
    end

    send_data csv.join(''), :filename => options[:filename], :type => 'text/csv'
  end
end
